#include <sys/types.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <stdio.h>
#ifdef SVR4
#include <fcntl.h>
#endif

#define BUFSIZE 512
#define LENGTH	50
#define PROC	"/usr/local/lib/do.sed"

static char sccsid[]="%W%\t%H% %T%";
static char word1[]="\\input{";
static char word2[]="lude{";

void look(name)
char *name;
{
	register int fd, i, head_of_line, has_a_file, ignored;
	register char *s, *t, *u;
	char buffer[BUFSIZE], nameo[LENGTH], namee[LENGTH], namep[LENGTH];
	struct stat ste, sto;

	sprintf(nameo,"%s.tox",name);
	sprintf(namee,"%s.tex",name);

	if( stat(nameo,&sto) < 0)
		if(stat(namee,&ste) < 0) {	/* Nobody, cry */
			fprintf(stderr,"srch: File %s not found\n",name);
			return;
		}
		else						/* .tex only, do nothing */
			return;
	else
		if(stat(namee,&ste) < 0) {	/* .tox, but no .tex */
			printf("%s %s\n",PROC,name);
		}
		else						/* .tex and .tox co-exist */
		{
			if(ste.st_ctime < sto.st_ctime)
				printf("%s %s\n",PROC,name);
		}

	if((fd = open(nameo,O_RDONLY)) < 0) {
		fprintf(stderr,"Unable to read %s\n",nameo);
		exit(1);
	}

	ignored = 0; head_of_line = 1; has_a_file = 0; t = word1;
	while((i = read(fd,buffer,BUFSIZE)) > 0) 
		for(s = buffer; --i >= 0;s++)
			if (ignored)
				if (*s == '\n') {
					ignored = 0;
					head_of_line = 0;
					t = word1;
				} else;
			else if (has_a_file)
				if (*s == '}') {
					*u = 0;
					look(namee);
					has_a_file = 0;
					t = word1;
				} else if (*s == '\n') {
					has_a_file = 0;
					t = word1;
					fprintf(stderr,
						"srch: error interpreting file %s\n",nameo);
					head_of_line = 1;
				} else *u++ = *s;
			else {
				if (*s == '\n') {
					head_of_line = 1;
					t = word1;
				} else if (*s == '%') ignored++;
				else if (head_of_line)
					if ((*s != '\t') && (*s != ' ')) head_of_line = 0;
				if (!head_of_line)
					if (*s != *t++) {
						if ((*t == 'u') && (*s == 'c')) t = word2;
						else t = word1;
					}
					else if (!*t) {
						has_a_file++;
						u = namee;
					}
			}
		close(fd);
}


main(argc,argv)
int argc;
char **argv;
{

	if(argc != 2) {
		fprintf(stderr,"srch: bad call\n");
		exit(1);
	}

	look(argv[1]);
}
